package com.hai.dao;

import com.hai.entity.EtcCarMsg;
import com.hai.entity.EtcCarMsgExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface EtcCarMsgMapper extends EtcCarMsgMapperExt {
    @SelectProvider(type=EtcCarMsgSqlProvider.class, method="countByExample")
    long countByExample(EtcCarMsgExample example);

    @DeleteProvider(type=EtcCarMsgSqlProvider.class, method="deleteByExample")
    int deleteByExample(EtcCarMsgExample example);

    @Delete({
        "delete from etc_car_msg",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into etc_car_msg (cust_id, veh_id, ",
        "product_id, card_variety_id, ",
        "veh_plate_no, veh_plate_color, ",
        "veh_type, veh_type_name, ",
        "axles_num, wheels_num, ",
        "drivLic_main_fro, drivLic_sub_fro, ",
        "head_stock_photo, create_time, ",
        "update_time, card_no, ",
        "obu_no, pay_status, ",
        "sign_status, veh_status, ",
        "user_id, user_name, ",
        "ext_1, ext_2, ext_3)",
        "values (#{custId,jdbcType=VARCHAR}, #{vehId,jdbcType=VARCHAR}, ",
        "#{productId,jdbcType=INTEGER}, #{cardVarietyId,jdbcType=INTEGER}, ",
        "#{vehPlateNo,jdbcType=VARCHAR}, #{vehPlateColor,jdbcType=INTEGER}, ",
        "#{vehType,jdbcType=VARCHAR}, #{vehTypeName,jdbcType=VARCHAR}, ",
        "#{axlesNum,jdbcType=INTEGER}, #{wheelsNum,jdbcType=INTEGER}, ",
        "#{drivlicMainFro,jdbcType=VARCHAR}, #{drivlicSubFro,jdbcType=VARCHAR}, ",
        "#{headStockPhoto,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{cardNo,jdbcType=VARCHAR}, ",
        "#{obuNo,jdbcType=VARCHAR}, #{payStatus,jdbcType=INTEGER}, ",
        "#{signStatus,jdbcType=INTEGER}, #{vehStatus,jdbcType=INTEGER}, ",
        "#{userId,jdbcType=BIGINT}, #{userName,jdbcType=VARCHAR}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(EtcCarMsg record);

    @InsertProvider(type=EtcCarMsgSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(EtcCarMsg record);

    @SelectProvider(type=EtcCarMsgSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="cust_id", property="custId", jdbcType=JdbcType.VARCHAR),
        @Result(column="veh_id", property="vehId", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.INTEGER),
        @Result(column="card_variety_id", property="cardVarietyId", jdbcType=JdbcType.INTEGER),
        @Result(column="veh_plate_no", property="vehPlateNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="veh_plate_color", property="vehPlateColor", jdbcType=JdbcType.INTEGER),
        @Result(column="veh_type", property="vehType", jdbcType=JdbcType.VARCHAR),
        @Result(column="veh_type_name", property="vehTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="axles_num", property="axlesNum", jdbcType=JdbcType.INTEGER),
        @Result(column="wheels_num", property="wheelsNum", jdbcType=JdbcType.INTEGER),
        @Result(column="drivLic_main_fro", property="drivlicMainFro", jdbcType=JdbcType.VARCHAR),
        @Result(column="drivLic_sub_fro", property="drivlicSubFro", jdbcType=JdbcType.VARCHAR),
        @Result(column="head_stock_photo", property="headStockPhoto", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="card_no", property="cardNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="obu_no", property="obuNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_status", property="payStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="sign_status", property="signStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="veh_status", property="vehStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_name", property="userName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<EtcCarMsg> selectByExample(EtcCarMsgExample example);

    @Select({
        "select",
        "id, cust_id, veh_id, product_id, card_variety_id, veh_plate_no, veh_plate_color, ",
        "veh_type, veh_type_name, axles_num, wheels_num, drivLic_main_fro, drivLic_sub_fro, ",
        "head_stock_photo, create_time, update_time, card_no, obu_no, pay_status, sign_status, ",
        "veh_status, user_id, user_name, ext_1, ext_2, ext_3",
        "from etc_car_msg",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="cust_id", property="custId", jdbcType=JdbcType.VARCHAR),
        @Result(column="veh_id", property="vehId", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.INTEGER),
        @Result(column="card_variety_id", property="cardVarietyId", jdbcType=JdbcType.INTEGER),
        @Result(column="veh_plate_no", property="vehPlateNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="veh_plate_color", property="vehPlateColor", jdbcType=JdbcType.INTEGER),
        @Result(column="veh_type", property="vehType", jdbcType=JdbcType.VARCHAR),
        @Result(column="veh_type_name", property="vehTypeName", jdbcType=JdbcType.VARCHAR),
        @Result(column="axles_num", property="axlesNum", jdbcType=JdbcType.INTEGER),
        @Result(column="wheels_num", property="wheelsNum", jdbcType=JdbcType.INTEGER),
        @Result(column="drivLic_main_fro", property="drivlicMainFro", jdbcType=JdbcType.VARCHAR),
        @Result(column="drivLic_sub_fro", property="drivlicSubFro", jdbcType=JdbcType.VARCHAR),
        @Result(column="head_stock_photo", property="headStockPhoto", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="card_no", property="cardNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="obu_no", property="obuNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="pay_status", property="payStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="sign_status", property="signStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="veh_status", property="vehStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_name", property="userName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    EtcCarMsg selectByPrimaryKey(Long id);

    @UpdateProvider(type=EtcCarMsgSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") EtcCarMsg record, @Param("example") EtcCarMsgExample example);

    @UpdateProvider(type=EtcCarMsgSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") EtcCarMsg record, @Param("example") EtcCarMsgExample example);

    @UpdateProvider(type=EtcCarMsgSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(EtcCarMsg record);

    @Update({
        "update etc_car_msg",
        "set cust_id = #{custId,jdbcType=VARCHAR},",
          "veh_id = #{vehId,jdbcType=VARCHAR},",
          "product_id = #{productId,jdbcType=INTEGER},",
          "card_variety_id = #{cardVarietyId,jdbcType=INTEGER},",
          "veh_plate_no = #{vehPlateNo,jdbcType=VARCHAR},",
          "veh_plate_color = #{vehPlateColor,jdbcType=INTEGER},",
          "veh_type = #{vehType,jdbcType=VARCHAR},",
          "veh_type_name = #{vehTypeName,jdbcType=VARCHAR},",
          "axles_num = #{axlesNum,jdbcType=INTEGER},",
          "wheels_num = #{wheelsNum,jdbcType=INTEGER},",
          "drivLic_main_fro = #{drivlicMainFro,jdbcType=VARCHAR},",
          "drivLic_sub_fro = #{drivlicSubFro,jdbcType=VARCHAR},",
          "head_stock_photo = #{headStockPhoto,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "card_no = #{cardNo,jdbcType=VARCHAR},",
          "obu_no = #{obuNo,jdbcType=VARCHAR},",
          "pay_status = #{payStatus,jdbcType=INTEGER},",
          "sign_status = #{signStatus,jdbcType=INTEGER},",
          "veh_status = #{vehStatus,jdbcType=INTEGER},",
          "user_id = #{userId,jdbcType=BIGINT},",
          "user_name = #{userName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(EtcCarMsg record);
}