package com.hai.dao;

import com.hai.entity.EtcCarMsg;
import com.hai.entity.EtcCarMsgExample.Criteria;
import com.hai.entity.EtcCarMsgExample.Criterion;
import com.hai.entity.EtcCarMsgExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class EtcCarMsgSqlProvider {

    public String countByExample(EtcCarMsgExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("etc_car_msg");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(EtcCarMsgExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("etc_car_msg");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(EtcCarMsg record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("etc_car_msg");
        
        if (record.getCustId() != null) {
            sql.VALUES("cust_id", "#{custId,jdbcType=VARCHAR}");
        }
        
        if (record.getVehId() != null) {
            sql.VALUES("veh_id", "#{vehId,jdbcType=VARCHAR}");
        }
        
        if (record.getProductId() != null) {
            sql.VALUES("product_id", "#{productId,jdbcType=INTEGER}");
        }
        
        if (record.getCardVarietyId() != null) {
            sql.VALUES("card_variety_id", "#{cardVarietyId,jdbcType=INTEGER}");
        }
        
        if (record.getVehPlateNo() != null) {
            sql.VALUES("veh_plate_no", "#{vehPlateNo,jdbcType=VARCHAR}");
        }
        
        if (record.getVehPlateColor() != null) {
            sql.VALUES("veh_plate_color", "#{vehPlateColor,jdbcType=INTEGER}");
        }
        
        if (record.getVehType() != null) {
            sql.VALUES("veh_type", "#{vehType,jdbcType=VARCHAR}");
        }
        
        if (record.getVehTypeName() != null) {
            sql.VALUES("veh_type_name", "#{vehTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getAxlesNum() != null) {
            sql.VALUES("axles_num", "#{axlesNum,jdbcType=INTEGER}");
        }
        
        if (record.getWheelsNum() != null) {
            sql.VALUES("wheels_num", "#{wheelsNum,jdbcType=INTEGER}");
        }
        
        if (record.getDrivlicMainFro() != null) {
            sql.VALUES("drivLic_main_fro", "#{drivlicMainFro,jdbcType=VARCHAR}");
        }
        
        if (record.getDrivlicSubFro() != null) {
            sql.VALUES("drivLic_sub_fro", "#{drivlicSubFro,jdbcType=VARCHAR}");
        }
        
        if (record.getHeadStockPhoto() != null) {
            sql.VALUES("head_stock_photo", "#{headStockPhoto,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCardNo() != null) {
            sql.VALUES("card_no", "#{cardNo,jdbcType=VARCHAR}");
        }
        
        if (record.getObuNo() != null) {
            sql.VALUES("obu_no", "#{obuNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayStatus() != null) {
            sql.VALUES("pay_status", "#{payStatus,jdbcType=INTEGER}");
        }
        
        if (record.getSignStatus() != null) {
            sql.VALUES("sign_status", "#{signStatus,jdbcType=INTEGER}");
        }
        
        if (record.getVehStatus() != null) {
            sql.VALUES("veh_status", "#{vehStatus,jdbcType=INTEGER}");
        }
        
        if (record.getUserId() != null) {
            sql.VALUES("user_id", "#{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserName() != null) {
            sql.VALUES("user_name", "#{userName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(EtcCarMsgExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("cust_id");
        sql.SELECT("veh_id");
        sql.SELECT("product_id");
        sql.SELECT("card_variety_id");
        sql.SELECT("veh_plate_no");
        sql.SELECT("veh_plate_color");
        sql.SELECT("veh_type");
        sql.SELECT("veh_type_name");
        sql.SELECT("axles_num");
        sql.SELECT("wheels_num");
        sql.SELECT("drivLic_main_fro");
        sql.SELECT("drivLic_sub_fro");
        sql.SELECT("head_stock_photo");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("card_no");
        sql.SELECT("obu_no");
        sql.SELECT("pay_status");
        sql.SELECT("sign_status");
        sql.SELECT("veh_status");
        sql.SELECT("user_id");
        sql.SELECT("user_name");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("etc_car_msg");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        EtcCarMsg record = (EtcCarMsg) parameter.get("record");
        EtcCarMsgExample example = (EtcCarMsgExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("etc_car_msg");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getCustId() != null) {
            sql.SET("cust_id = #{record.custId,jdbcType=VARCHAR}");
        }
        
        if (record.getVehId() != null) {
            sql.SET("veh_id = #{record.vehId,jdbcType=VARCHAR}");
        }
        
        if (record.getProductId() != null) {
            sql.SET("product_id = #{record.productId,jdbcType=INTEGER}");
        }
        
        if (record.getCardVarietyId() != null) {
            sql.SET("card_variety_id = #{record.cardVarietyId,jdbcType=INTEGER}");
        }
        
        if (record.getVehPlateNo() != null) {
            sql.SET("veh_plate_no = #{record.vehPlateNo,jdbcType=VARCHAR}");
        }
        
        if (record.getVehPlateColor() != null) {
            sql.SET("veh_plate_color = #{record.vehPlateColor,jdbcType=INTEGER}");
        }
        
        if (record.getVehType() != null) {
            sql.SET("veh_type = #{record.vehType,jdbcType=VARCHAR}");
        }
        
        if (record.getVehTypeName() != null) {
            sql.SET("veh_type_name = #{record.vehTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getAxlesNum() != null) {
            sql.SET("axles_num = #{record.axlesNum,jdbcType=INTEGER}");
        }
        
        if (record.getWheelsNum() != null) {
            sql.SET("wheels_num = #{record.wheelsNum,jdbcType=INTEGER}");
        }
        
        if (record.getDrivlicMainFro() != null) {
            sql.SET("drivLic_main_fro = #{record.drivlicMainFro,jdbcType=VARCHAR}");
        }
        
        if (record.getDrivlicSubFro() != null) {
            sql.SET("drivLic_sub_fro = #{record.drivlicSubFro,jdbcType=VARCHAR}");
        }
        
        if (record.getHeadStockPhoto() != null) {
            sql.SET("head_stock_photo = #{record.headStockPhoto,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCardNo() != null) {
            sql.SET("card_no = #{record.cardNo,jdbcType=VARCHAR}");
        }
        
        if (record.getObuNo() != null) {
            sql.SET("obu_no = #{record.obuNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayStatus() != null) {
            sql.SET("pay_status = #{record.payStatus,jdbcType=INTEGER}");
        }
        
        if (record.getSignStatus() != null) {
            sql.SET("sign_status = #{record.signStatus,jdbcType=INTEGER}");
        }
        
        if (record.getVehStatus() != null) {
            sql.SET("veh_status = #{record.vehStatus,jdbcType=INTEGER}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserName() != null) {
            sql.SET("user_name = #{record.userName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("etc_car_msg");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("cust_id = #{record.custId,jdbcType=VARCHAR}");
        sql.SET("veh_id = #{record.vehId,jdbcType=VARCHAR}");
        sql.SET("product_id = #{record.productId,jdbcType=INTEGER}");
        sql.SET("card_variety_id = #{record.cardVarietyId,jdbcType=INTEGER}");
        sql.SET("veh_plate_no = #{record.vehPlateNo,jdbcType=VARCHAR}");
        sql.SET("veh_plate_color = #{record.vehPlateColor,jdbcType=INTEGER}");
        sql.SET("veh_type = #{record.vehType,jdbcType=VARCHAR}");
        sql.SET("veh_type_name = #{record.vehTypeName,jdbcType=VARCHAR}");
        sql.SET("axles_num = #{record.axlesNum,jdbcType=INTEGER}");
        sql.SET("wheels_num = #{record.wheelsNum,jdbcType=INTEGER}");
        sql.SET("drivLic_main_fro = #{record.drivlicMainFro,jdbcType=VARCHAR}");
        sql.SET("drivLic_sub_fro = #{record.drivlicSubFro,jdbcType=VARCHAR}");
        sql.SET("head_stock_photo = #{record.headStockPhoto,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("card_no = #{record.cardNo,jdbcType=VARCHAR}");
        sql.SET("obu_no = #{record.obuNo,jdbcType=VARCHAR}");
        sql.SET("pay_status = #{record.payStatus,jdbcType=INTEGER}");
        sql.SET("sign_status = #{record.signStatus,jdbcType=INTEGER}");
        sql.SET("veh_status = #{record.vehStatus,jdbcType=INTEGER}");
        sql.SET("user_id = #{record.userId,jdbcType=BIGINT}");
        sql.SET("user_name = #{record.userName,jdbcType=VARCHAR}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        EtcCarMsgExample example = (EtcCarMsgExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(EtcCarMsg record) {
        SQL sql = new SQL();
        sql.UPDATE("etc_car_msg");
        
        if (record.getCustId() != null) {
            sql.SET("cust_id = #{custId,jdbcType=VARCHAR}");
        }
        
        if (record.getVehId() != null) {
            sql.SET("veh_id = #{vehId,jdbcType=VARCHAR}");
        }
        
        if (record.getProductId() != null) {
            sql.SET("product_id = #{productId,jdbcType=INTEGER}");
        }
        
        if (record.getCardVarietyId() != null) {
            sql.SET("card_variety_id = #{cardVarietyId,jdbcType=INTEGER}");
        }
        
        if (record.getVehPlateNo() != null) {
            sql.SET("veh_plate_no = #{vehPlateNo,jdbcType=VARCHAR}");
        }
        
        if (record.getVehPlateColor() != null) {
            sql.SET("veh_plate_color = #{vehPlateColor,jdbcType=INTEGER}");
        }
        
        if (record.getVehType() != null) {
            sql.SET("veh_type = #{vehType,jdbcType=VARCHAR}");
        }
        
        if (record.getVehTypeName() != null) {
            sql.SET("veh_type_name = #{vehTypeName,jdbcType=VARCHAR}");
        }
        
        if (record.getAxlesNum() != null) {
            sql.SET("axles_num = #{axlesNum,jdbcType=INTEGER}");
        }
        
        if (record.getWheelsNum() != null) {
            sql.SET("wheels_num = #{wheelsNum,jdbcType=INTEGER}");
        }
        
        if (record.getDrivlicMainFro() != null) {
            sql.SET("drivLic_main_fro = #{drivlicMainFro,jdbcType=VARCHAR}");
        }
        
        if (record.getDrivlicSubFro() != null) {
            sql.SET("drivLic_sub_fro = #{drivlicSubFro,jdbcType=VARCHAR}");
        }
        
        if (record.getHeadStockPhoto() != null) {
            sql.SET("head_stock_photo = #{headStockPhoto,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCardNo() != null) {
            sql.SET("card_no = #{cardNo,jdbcType=VARCHAR}");
        }
        
        if (record.getObuNo() != null) {
            sql.SET("obu_no = #{obuNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPayStatus() != null) {
            sql.SET("pay_status = #{payStatus,jdbcType=INTEGER}");
        }
        
        if (record.getSignStatus() != null) {
            sql.SET("sign_status = #{signStatus,jdbcType=INTEGER}");
        }
        
        if (record.getVehStatus() != null) {
            sql.SET("veh_status = #{vehStatus,jdbcType=INTEGER}");
        }
        
        if (record.getUserId() != null) {
            sql.SET("user_id = #{userId,jdbcType=BIGINT}");
        }
        
        if (record.getUserName() != null) {
            sql.SET("user_name = #{userName,jdbcType=VARCHAR}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, EtcCarMsgExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}