package com.hai.dao;

import com.hai.entity.EtcContractOrder;
import com.hai.entity.EtcContractOrderExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface EtcContractOrderMapper extends EtcContractOrderMapperExt {
    @SelectProvider(type=EtcContractOrderSqlProvider.class, method="countByExample")
    long countByExample(EtcContractOrderExample example);

    @DeleteProvider(type=EtcContractOrderSqlProvider.class, method="deleteByExample")
    int deleteByExample(EtcContractOrderExample example);

    @Delete({
        "delete from etc_contract_order",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into etc_contract_order (phone, contract_no, ",
        "cust_id, veh_id, product_id, ",
        "card_variety_id, product_name, ",
        "card_variety_name, sign_img, ",
        "create_time, update_time, ",
        "`status`, pay_status, ",
        "sign_status, bank_sign, ",
        "wechat_sign, need_sign_wechat, ",
        "veh_status, jump_path, ",
        "appId, op_id, op_name, ",
        "ext_1, ext_2, ext_3)",
        "values (#{phone,jdbcType=VARCHAR}, #{contractNo,jdbcType=VARCHAR}, ",
        "#{custId,jdbcType=VARCHAR}, #{vehId,jdbcType=VARCHAR}, #{productId,jdbcType=INTEGER}, ",
        "#{cardVarietyId,jdbcType=INTEGER}, #{productName,jdbcType=VARCHAR}, ",
        "#{cardVarietyName,jdbcType=VARCHAR}, #{signImg,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{payStatus,jdbcType=INTEGER}, ",
        "#{signStatus,jdbcType=INTEGER}, #{bankSign,jdbcType=INTEGER}, ",
        "#{wechatSign,jdbcType=INTEGER}, #{needSignWechat,jdbcType=INTEGER}, ",
        "#{vehStatus,jdbcType=INTEGER}, #{jumpPath,jdbcType=VARCHAR}, ",
        "#{appid,jdbcType=VARCHAR}, #{opId,jdbcType=BIGINT}, #{opName,jdbcType=VARCHAR}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(EtcContractOrder record);

    @InsertProvider(type=EtcContractOrderSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(EtcContractOrder record);

    @SelectProvider(type=EtcContractOrderSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="phone", property="phone", jdbcType=JdbcType.VARCHAR),
        @Result(column="contract_no", property="contractNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="cust_id", property="custId", jdbcType=JdbcType.VARCHAR),
        @Result(column="veh_id", property="vehId", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.INTEGER),
        @Result(column="card_variety_id", property="cardVarietyId", jdbcType=JdbcType.INTEGER),
        @Result(column="product_name", property="productName", jdbcType=JdbcType.VARCHAR),
        @Result(column="card_variety_name", property="cardVarietyName", jdbcType=JdbcType.VARCHAR),
        @Result(column="sign_img", property="signImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_status", property="payStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="sign_status", property="signStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="bank_sign", property="bankSign", jdbcType=JdbcType.INTEGER),
        @Result(column="wechat_sign", property="wechatSign", jdbcType=JdbcType.INTEGER),
        @Result(column="need_sign_wechat", property="needSignWechat", jdbcType=JdbcType.INTEGER),
        @Result(column="veh_status", property="vehStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="jump_path", property="jumpPath", jdbcType=JdbcType.VARCHAR),
        @Result(column="appId", property="appid", jdbcType=JdbcType.VARCHAR),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<EtcContractOrder> selectByExample(EtcContractOrderExample example);

    @Select({
        "select",
        "id, phone, contract_no, cust_id, veh_id, product_id, card_variety_id, product_name, ",
        "card_variety_name, sign_img, create_time, update_time, `status`, pay_status, ",
        "sign_status, bank_sign, wechat_sign, need_sign_wechat, veh_status, jump_path, ",
        "appId, op_id, op_name, ext_1, ext_2, ext_3",
        "from etc_contract_order",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="phone", property="phone", jdbcType=JdbcType.VARCHAR),
        @Result(column="contract_no", property="contractNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="cust_id", property="custId", jdbcType=JdbcType.VARCHAR),
        @Result(column="veh_id", property="vehId", jdbcType=JdbcType.VARCHAR),
        @Result(column="product_id", property="productId", jdbcType=JdbcType.INTEGER),
        @Result(column="card_variety_id", property="cardVarietyId", jdbcType=JdbcType.INTEGER),
        @Result(column="product_name", property="productName", jdbcType=JdbcType.VARCHAR),
        @Result(column="card_variety_name", property="cardVarietyName", jdbcType=JdbcType.VARCHAR),
        @Result(column="sign_img", property="signImg", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="pay_status", property="payStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="sign_status", property="signStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="bank_sign", property="bankSign", jdbcType=JdbcType.INTEGER),
        @Result(column="wechat_sign", property="wechatSign", jdbcType=JdbcType.INTEGER),
        @Result(column="need_sign_wechat", property="needSignWechat", jdbcType=JdbcType.INTEGER),
        @Result(column="veh_status", property="vehStatus", jdbcType=JdbcType.INTEGER),
        @Result(column="jump_path", property="jumpPath", jdbcType=JdbcType.VARCHAR),
        @Result(column="appId", property="appid", jdbcType=JdbcType.VARCHAR),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    EtcContractOrder selectByPrimaryKey(Long id);

    @UpdateProvider(type=EtcContractOrderSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") EtcContractOrder record, @Param("example") EtcContractOrderExample example);

    @UpdateProvider(type=EtcContractOrderSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") EtcContractOrder record, @Param("example") EtcContractOrderExample example);

    @UpdateProvider(type=EtcContractOrderSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(EtcContractOrder record);

    @Update({
        "update etc_contract_order",
        "set phone = #{phone,jdbcType=VARCHAR},",
          "contract_no = #{contractNo,jdbcType=VARCHAR},",
          "cust_id = #{custId,jdbcType=VARCHAR},",
          "veh_id = #{vehId,jdbcType=VARCHAR},",
          "product_id = #{productId,jdbcType=INTEGER},",
          "card_variety_id = #{cardVarietyId,jdbcType=INTEGER},",
          "product_name = #{productName,jdbcType=VARCHAR},",
          "card_variety_name = #{cardVarietyName,jdbcType=VARCHAR},",
          "sign_img = #{signImg,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "pay_status = #{payStatus,jdbcType=INTEGER},",
          "sign_status = #{signStatus,jdbcType=INTEGER},",
          "bank_sign = #{bankSign,jdbcType=INTEGER},",
          "wechat_sign = #{wechatSign,jdbcType=INTEGER},",
          "need_sign_wechat = #{needSignWechat,jdbcType=INTEGER},",
          "veh_status = #{vehStatus,jdbcType=INTEGER},",
          "jump_path = #{jumpPath,jdbcType=VARCHAR},",
          "appId = #{appid,jdbcType=VARCHAR},",
          "op_id = #{opId,jdbcType=BIGINT},",
          "op_name = #{opName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(EtcContractOrder record);
}