package com.hai.dao;

import com.hai.entity.EtcCustMsg;
import com.hai.entity.EtcCustMsgExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface EtcCustMsgMapper extends EtcCustMsgMapperExt {
    @SelectProvider(type=EtcCustMsgSqlProvider.class, method="countByExample")
    long countByExample(EtcCustMsgExample example);

    @DeleteProvider(type=EtcCustMsgSqlProvider.class, method="deleteByExample")
    int deleteByExample(EtcCustMsgExample example);

    @Delete({
        "delete from etc_cust_msg",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into etc_cust_msg (cust_id, cust_name, ",
        "phone, cust_id_no, ",
        "cust_agent_id_front, cust_agent_id_bront, ",
        "account_no, bank_name, ",
        "address, bank_phone, ",
        "bank_card, create_time, ",
        "update_time, `status`, ",
        "user_id, user_name, ",
        "ext_1, ext_2, ext_3)",
        "values (#{custId,jdbcType=VARCHAR}, #{custName,jdbcType=VARCHAR}, ",
        "#{phone,jdbcType=VARCHAR}, #{custIdNo,jdbcType=VARCHAR}, ",
        "#{custAgentIdFront,jdbcType=VARCHAR}, #{custAgentIdBront,jdbcType=VARCHAR}, ",
        "#{accountNo,jdbcType=VARCHAR}, #{bankName,jdbcType=VARCHAR}, ",
        "#{address,jdbcType=VARCHAR}, #{bankPhone,jdbcType=VARCHAR}, ",
        "#{bankCard,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{status,jdbcType=INTEGER}, ",
        "#{userId,jdbcType=BIGINT}, #{userName,jdbcType=VARCHAR}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(EtcCustMsg record);

    @InsertProvider(type=EtcCustMsgSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(EtcCustMsg record);

    @SelectProvider(type=EtcCustMsgSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="cust_id", property="custId", jdbcType=JdbcType.VARCHAR),
        @Result(column="cust_name", property="custName", jdbcType=JdbcType.VARCHAR),
        @Result(column="phone", property="phone", jdbcType=JdbcType.VARCHAR),
        @Result(column="cust_id_no", property="custIdNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="cust_agent_id_front", property="custAgentIdFront", jdbcType=JdbcType.VARCHAR),
        @Result(column="cust_agent_id_bront", property="custAgentIdBront", jdbcType=JdbcType.VARCHAR),
        @Result(column="account_no", property="accountNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="bank_name", property="bankName", jdbcType=JdbcType.VARCHAR),
        @Result(column="address", property="address", jdbcType=JdbcType.VARCHAR),
        @Result(column="bank_phone", property="bankPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="bank_card", property="bankCard", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_name", property="userName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<EtcCustMsg> selectByExample(EtcCustMsgExample example);

    @Select({
        "select",
        "id, cust_id, cust_name, phone, cust_id_no, cust_agent_id_front, cust_agent_id_bront, ",
        "account_no, bank_name, address, bank_phone, bank_card, create_time, update_time, ",
        "`status`, user_id, user_name, ext_1, ext_2, ext_3",
        "from etc_cust_msg",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="cust_id", property="custId", jdbcType=JdbcType.VARCHAR),
        @Result(column="cust_name", property="custName", jdbcType=JdbcType.VARCHAR),
        @Result(column="phone", property="phone", jdbcType=JdbcType.VARCHAR),
        @Result(column="cust_id_no", property="custIdNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="cust_agent_id_front", property="custAgentIdFront", jdbcType=JdbcType.VARCHAR),
        @Result(column="cust_agent_id_bront", property="custAgentIdBront", jdbcType=JdbcType.VARCHAR),
        @Result(column="account_no", property="accountNo", jdbcType=JdbcType.VARCHAR),
        @Result(column="bank_name", property="bankName", jdbcType=JdbcType.VARCHAR),
        @Result(column="address", property="address", jdbcType=JdbcType.VARCHAR),
        @Result(column="bank_phone", property="bankPhone", jdbcType=JdbcType.VARCHAR),
        @Result(column="bank_card", property="bankCard", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_name", property="userName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    EtcCustMsg selectByPrimaryKey(Long id);

    @UpdateProvider(type=EtcCustMsgSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") EtcCustMsg record, @Param("example") EtcCustMsgExample example);

    @UpdateProvider(type=EtcCustMsgSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") EtcCustMsg record, @Param("example") EtcCustMsgExample example);

    @UpdateProvider(type=EtcCustMsgSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(EtcCustMsg record);

    @Update({
        "update etc_cust_msg",
        "set cust_id = #{custId,jdbcType=VARCHAR},",
          "cust_name = #{custName,jdbcType=VARCHAR},",
          "phone = #{phone,jdbcType=VARCHAR},",
          "cust_id_no = #{custIdNo,jdbcType=VARCHAR},",
          "cust_agent_id_front = #{custAgentIdFront,jdbcType=VARCHAR},",
          "cust_agent_id_bront = #{custAgentIdBront,jdbcType=VARCHAR},",
          "account_no = #{accountNo,jdbcType=VARCHAR},",
          "bank_name = #{bankName,jdbcType=VARCHAR},",
          "address = #{address,jdbcType=VARCHAR},",
          "bank_phone = #{bankPhone,jdbcType=VARCHAR},",
          "bank_card = #{bankCard,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "user_id = #{userId,jdbcType=BIGINT},",
          "user_name = #{userName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(EtcCustMsg record);
}