package com.hai.etc;

import com.hai.entity.EtcCustMsg;

import java.util.List;
import java.util.Map;

/**
 * @serviceName .java
 * @author Sum1Dream
 * @version 1.0.0
 * @Description // etc客户信息
 * @createTime 16:03 2024/3/22
 **/
public interface EtcCustMsgService {

    /**
     * @Author Sum1Dream
     * @Name insertCust
     * @Description // 新增客户信息
     * @Date 11:29 2023/9/5
     * @Param CustInfo
     * @return void
     */
    void insertEtcCust(EtcCustMsg etcCustMsg);

    /**
     * @Author Sum1Dream
     * @Name updateCust
     * @Description // 更新客户信息
     * @Date 11:29 2023/9/5
     * @Param CustInfo
     * @return void
     */
    void updateEtcCust(EtcCustMsg etcCustMsg) throws Exception;


    void editEtcCust(EtcCustMsg etcCustMsg) throws Exception;

    /**
     * @Author Sum1Dream
     * @Name getCustInfoList
     * @Description // 查询客户信息列表
     * @Date 11:30 2023/9/5
     * @Param map
     * @return java.util.List<com.hai.entity.BlxCustInfo>
     */
    List<EtcCustMsg> getEtcCustList(Map<String , Object> map);

    /**
     * @Author Sum1Dream
     * @Name findCustInfoByMap
     * @Description //TODO
     * @Date 14:14 2023/9/5
     * @Param map
     * @return com.hai.entity.BlxCustInfo
     */
    EtcCustMsg findEtcCustByMap(Map<String , Object> map);

    /**
     * @Author Sum1Dream
     * @Name findCustInfoById
     * @Description // 根据ID查询详情
     * @Date 15:13 2023/9/5
     * @Param id
     * @return com.hai.entity.BlxCustInfo
     */
    EtcCustMsg findEtcCustById(Long id);



    

}
