package com.hai.service;

import com.hai.entity.HighGasOilGunNo;

import java.util.List;
import java.util.Map;

/**
 * 油站枪号
 * @author hurui
 */
public interface HighGasOilGunNoService {

    /**
     * 编辑抢号
     * @param gasOilGunNo
     */
    void editGunNo(HighGasOilGunNo gasOilGunNo);

    /**
     * 删除抢号
     * @param id
     */
    HighGasOilGunNo getGunNoById(Long id);

    /**
     * 清除油号
     * @param storeId
     */
    void cleanGunNo(Long storeId);

    /**
     * 根据门店和抢号查询
     * @param storeId
     * @param gunNo
     * @return
     */
    HighGasOilGunNo getDetailByStoreAndGunNo(Long storeId, String gunNo);

    /**
     * 查询抢号列表
     * @param oilPriceId
     * @return
     */
    List<HighGasOilGunNo> getGunNoListByOilPrice(Long oilPriceId);

    /**
     * 根据门店 查询抢号列表
     * @param storeId
     * @return
     */
    List<HighGasOilGunNo> getGunNoListByStoreId(Long storeId);

    /**
    * @Author Sum1Dream
    * @Name getGunNoList
    * @Description //TODO
    * @Date 18:06 2023/12/4
    * @Param map
     * @return java.util.List<com.hai.entity.HighGasOilGunNo>
    */
    List<HighGasOilGunNo> getGunNoList(Map<String , Object> map);
}
