package com.hai.service.impl;

import com.hai.dao.BsTemporaryMapper;
import com.hai.entity.BsMsg;
import com.hai.entity.BsTemporary;
import com.hai.entity.BsTemporaryExample;
import com.hai.service.BsTemporaryServices;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

@Service("bsTemporaryServices")
public class BsTemporaryServicesImpl implements BsTemporaryServices {

    @Resource
    private BsTemporaryMapper bsTemporaryMapper;

    @Override
    public void insert(BsTemporary bsTemporary) {
        bsTemporaryMapper.insert(bsTemporary);
    }

    @Override
    public void update(BsTemporary bsTemporary) {
        bsTemporaryMapper.updateByPrimaryKey(bsTemporary);
    }

    @Override
    public BsTemporary findById(Long id) {
        return bsTemporaryMapper.selectByPrimaryKey(id);
    }

    @Override
    public BsTemporary findByCode(String openId ,  Integer type) {
        BsTemporaryExample example = new BsTemporaryExample();
        example.createCriteria().andSourceCodeEqualTo(openId).andTypeEqualTo(type).andStatusEqualTo(1);

        List<BsTemporary> list = bsTemporaryMapper.selectByExample(example);

        if (list.size() > 0 ) {
            return list.get(0);
        }

        return null;
    }

    @Override
    public List<BsTemporary> getList(Map<String, Object> map) {
        BsTemporaryExample example = new BsTemporaryExample();
        example.createCriteria().andStatusEqualTo(1);
        return bsTemporaryMapper.selectByExample(example);
    }
}
